/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.filters.ReindexRegularField;

import java.awt.Color;
import javax.swing.JRadioButton;

/**
 *
 ** @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class GUI extends javax.swing.JPanel
{

    private Params params;
    private int nDim = 3;
    private JRadioButton[][] buttons;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
        xGroup.add(xx);
        xGroup.add(xy);
        xGroup.add(xz);
        xGroup.add(x_x);
        xGroup.add(x_y);
        xGroup.add(x_z);
        yGroup.add(yx);
        yGroup.add(yy);
        yGroup.add(yz);
        yGroup.add(y_x);
        yGroup.add(y_y);
        yGroup.add(y_z);
        zGroup.add(zx);
        zGroup.add(zy);
        zGroup.add(zz);
        zGroup.add(z_x);
        zGroup.add(z_y);
        zGroup.add(z_z);
        buttons = new JRadioButton[][]{{xx, xy, xz, x_x, x_y, x_z},
                                       {yx, yy, yz, y_x, y_y, y_z},
                                       {zx, zy, zz, z_x, z_y, z_z}};
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        xGroup = new javax.swing.ButtonGroup();
        yGroup = new javax.swing.ButtonGroup();
        zGroup = new javax.swing.ButtonGroup();
        jLabel1 = new javax.swing.JLabel();
        xx = new javax.swing.JRadioButton();
        xy = new javax.swing.JRadioButton();
        xz = new javax.swing.JRadioButton();
        x_x = new javax.swing.JRadioButton();
        x_y = new javax.swing.JRadioButton();
        x_z = new javax.swing.JRadioButton();
        jLabel2 = new javax.swing.JLabel();
        yx = new javax.swing.JRadioButton();
        yy = new javax.swing.JRadioButton();
        yz = new javax.swing.JRadioButton();
        y_x = new javax.swing.JRadioButton();
        y_y = new javax.swing.JRadioButton();
        y_z = new javax.swing.JRadioButton();
        jLabel3 = new javax.swing.JLabel();
        zx = new javax.swing.JRadioButton();
        zy = new javax.swing.JRadioButton();
        zz = new javax.swing.JRadioButton();
        z_x = new javax.swing.JRadioButton();
        z_y = new javax.swing.JRadioButton();
        z_z = new javax.swing.JRadioButton();
        jPanel1 = new javax.swing.JPanel();

        setMinimumSize(new java.awt.Dimension(218, 90));
        setOpaque(false);
        setPreferredSize(new java.awt.Dimension(230, 90));
        setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("i");
        add(jLabel1, new java.awt.GridBagConstraints());

        xx.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        xx.setSelected(true);
        xx.setText("i");
        xx.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                xxActionPerformed(evt);
            }
        });
        add(xx, new java.awt.GridBagConstraints());

        xy.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        xy.setText("j");
        xy.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                xyActionPerformed(evt);
            }
        });
        add(xy, new java.awt.GridBagConstraints());

        xz.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        xz.setText("k");
        xz.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                xzActionPerformed(evt);
            }
        });
        add(xz, new java.awt.GridBagConstraints());

        x_x.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        x_x.setText("-i");
        x_x.setIconTextGap(1);
        x_x.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                x_xActionPerformed(evt);
            }
        });
        add(x_x, new java.awt.GridBagConstraints());

        x_y.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        x_y.setText("-j");
        x_y.setIconTextGap(1);
        x_y.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                x_yActionPerformed(evt);
            }
        });
        add(x_y, new java.awt.GridBagConstraints());

        x_z.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        x_z.setText("-k");
        x_z.setIconTextGap(1);
        x_z.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                x_zActionPerformed(evt);
            }
        });
        add(x_z, new java.awt.GridBagConstraints());

        jLabel2.setText("j");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        add(jLabel2, gridBagConstraints);

        yx.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        yx.setText("i");
        yx.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                yxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        add(yx, gridBagConstraints);

        yy.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        yy.setSelected(true);
        yy.setText("j");
        yy.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                yyActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        add(yy, gridBagConstraints);

        yz.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        yz.setText("k");
        yz.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                yzActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        add(yz, gridBagConstraints);

        y_x.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        y_x.setText("-i");
        y_x.setIconTextGap(1);
        y_x.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                y_xActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
        add(y_x, gridBagConstraints);

        y_y.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        y_y.setText("-j");
        y_y.setIconTextGap(1);
        y_y.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                y_yActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 1;
        add(y_y, gridBagConstraints);

        y_z.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        y_z.setText("-k");
        y_z.setIconTextGap(1);
        y_z.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                y_zActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 1;
        add(y_z, gridBagConstraints);

        jLabel3.setText("k");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        add(jLabel3, gridBagConstraints);

        zx.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        zx.setText("i");
        zx.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                zxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        add(zx, gridBagConstraints);

        zy.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        zy.setText("j");
        zy.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                zyActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        add(zy, gridBagConstraints);

        zz.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        zz.setSelected(true);
        zz.setText("k");
        zz.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                zzActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 2;
        add(zz, gridBagConstraints);

        z_x.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        z_x.setText("-i");
        z_x.setIconTextGap(1);
        z_x.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                z_xActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 2;
        add(z_x, gridBagConstraints);

        z_y.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        z_y.setText("-j");
        z_y.setIconTextGap(1);
        z_y.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                z_yActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 2;
        add(z_y, gridBagConstraints);

        z_z.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        z_z.setText("-k");
        z_z.setIconTextGap(1);
        z_z.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                z_zActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 2;
        add(z_z, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 0.1;
        add(jPanel1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void xxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_xxActionPerformed
    {//GEN-HEADEREND:event_xxActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_xxActionPerformed

    private void xyActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_xyActionPerformed
    {//GEN-HEADEREND:event_xyActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_xyActionPerformed

    private void xzActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_xzActionPerformed
    {//GEN-HEADEREND:event_xzActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_xzActionPerformed

    private void x_xActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_x_xActionPerformed
    {//GEN-HEADEREND:event_x_xActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_x_xActionPerformed

    private void x_yActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_x_yActionPerformed
    {//GEN-HEADEREND:event_x_yActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_x_yActionPerformed

    private void x_zActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_x_zActionPerformed
    {//GEN-HEADEREND:event_x_zActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_x_zActionPerformed

    private void yxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_yxActionPerformed
    {//GEN-HEADEREND:event_yxActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_yxActionPerformed

    private void yyActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_yyActionPerformed
    {//GEN-HEADEREND:event_yyActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_yyActionPerformed

    private void yzActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_yzActionPerformed
    {//GEN-HEADEREND:event_yzActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_yzActionPerformed

    private void y_xActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_y_xActionPerformed
    {//GEN-HEADEREND:event_y_xActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_y_xActionPerformed

    private void y_yActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_y_yActionPerformed
    {//GEN-HEADEREND:event_y_yActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_y_yActionPerformed

    private void y_zActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_y_zActionPerformed
    {//GEN-HEADEREND:event_y_zActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_y_zActionPerformed

    private void zxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_zxActionPerformed
    {//GEN-HEADEREND:event_zxActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_zxActionPerformed

    private void zyActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_zyActionPerformed
    {//GEN-HEADEREND:event_zyActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_zyActionPerformed

    private void zzActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_zzActionPerformed
    {//GEN-HEADEREND:event_zzActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_zzActionPerformed

    private void z_xActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_z_xActionPerformed
    {//GEN-HEADEREND:event_z_xActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_z_xActionPerformed

    private void z_yActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_z_yActionPerformed
    {//GEN-HEADEREND:event_z_yActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_z_yActionPerformed

    private void z_zActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_z_zActionPerformed
    {//GEN-HEADEREND:event_z_zActionPerformed
        checkAndUpdate();
    }//GEN-LAST:event_z_zActionPerformed

    public void setParams(Params params)
    {
        this.params = params;
    }

    public void setNDim(int nDim)
    {
        this.nDim = nDim;
        for (int i = 0; i < 3; i++)
            for (int j = 0; j < 6; j++) {
                buttons[i][j].setEnabled(true);
                buttons[i][j].setSelected(false);
            }
        if (nDim == 2) {
            for (int j = 0; j < 6; j++)
                buttons[2][j].setEnabled(false);
            for (int i = 0; i < 2; i++) {
                buttons[i][2].setEnabled(false);
                buttons[i][5].setEnabled(false);
            }
        }
        if (nDim == 1) {
            for (int i = 0; i < 3; i++)
                for (int j = 0; j < 6; j++) {
                    buttons[i][j].setEnabled(false);
                    buttons[i][j].setSelected(false);
                }
            buttons[0][0].setEnabled(true);
            buttons[0][3].setEnabled(true);
        }
        for (int i = 0; i < nDim; i++)
            buttons[i][i].setSelected(true);
    }

    private void checkAndUpdate()
    {
        for (int i = 0; i < 3; i++)
            for (int j = 0; j < 6; j++)
                if (buttons[i][j].isEnabled())
                    buttons[i][j].setForeground(new Color(51, 51, 51));
        boolean ok = true;
        for (int i = 0; i < nDim; i++) {
            int k = -1, l = -1;
            for (int j = 0; j < nDim; j++) {
                if (buttons[j][i].isSelected() || buttons[j][i + 3].isSelected()) {
                    if (k == -1) {
                        k = i;
                        l = j;
                    } else {
                        ok = false;
                        buttons[j][i].setForeground(Color.RED);
                        buttons[k][l].setForeground(Color.RED);
                    }
                }
            }
        }
        if (!ok)
            return;
        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 3; j++) {
                if (buttons[i][j].isSelected()) {
                    params.setCoordinate(i, j);
                    params.setMirror(i, false);
                }
                if (buttons[i][j + 3].isSelected()) {
                    params.setCoordinate(i, j);
                    params.setMirror(i, true);
                }
            }
        }
        params.fireStateChanged();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JLabel jLabel1;
    protected javax.swing.JLabel jLabel2;
    protected javax.swing.JLabel jLabel3;
    protected javax.swing.JPanel jPanel1;
    protected javax.swing.ButtonGroup xGroup;
    protected javax.swing.JRadioButton x_x;
    protected javax.swing.JRadioButton x_y;
    protected javax.swing.JRadioButton x_z;
    protected javax.swing.JRadioButton xx;
    protected javax.swing.JRadioButton xy;
    protected javax.swing.JRadioButton xz;
    protected javax.swing.ButtonGroup yGroup;
    protected javax.swing.JRadioButton y_x;
    protected javax.swing.JRadioButton y_y;
    protected javax.swing.JRadioButton y_z;
    protected javax.swing.JRadioButton yx;
    protected javax.swing.JRadioButton yy;
    protected javax.swing.JRadioButton yz;
    protected javax.swing.ButtonGroup zGroup;
    protected javax.swing.JRadioButton z_x;
    protected javax.swing.JRadioButton z_y;
    protected javax.swing.JRadioButton z_z;
    protected javax.swing.JRadioButton zx;
    protected javax.swing.JRadioButton zy;
    protected javax.swing.JRadioButton zz;
    // End of variables declaration//GEN-END:variables

}
